/************************************************************************************************************
// LightEvent Class ver 1.0 erstellt am 14. Juni 2007
//
// Diese Klasse verwaltet die weitergeleitetn Daten durch das Event. In dieser Klasse sind zudem alle
// verfgbaren Events fr das LightTracking definiert.
//
// Author: Florian Weil --- http://www.derhess.de
//
// Die Klasse kann frei fr nicht kommerzielle Zwecke verwendet werden. 
// Bei kommerzieller Verwendung bitte eine kurze Mail an info@derhess.de 
//

/************************************************************************************************************/

package de.derhess.iaCam
{	
	import flash.events.Event;
	import flash.geom.Rectangle;
	
	public class LightEvent extends Event
	{
		// Statische Variablen fr die Eventerzeugung
		public static const NO_LIGHT_FOUND:String = "NoLightFound";
		public static const RESULT_ONE_LIGHT:String = "ResultOneLight";
		public static const RESULT_MORE_LIGHTS:String = "ResultMoreLights";
		public static const ADD_LIGHT:String = "AddLight";
		public static const REMOVE_LIGHT:String = "RemoveLight";
		public static const TRACKING_FAILURE:String = "TrackingFailure";
		
		public var result:Rectangle
		public var resultArray:Array;
		public var difference:int;
		
		// Konstruktor
		function LightEvent (type:String,
							bubbles:Boolean = false,
							cancelable:Boolean=false,
							trackingResult:Rectangle=null,
							trackingResultArray:Array = null,
							diff:int = 0)
		{
			super(type,bubbles,cancelable);
			this.result = trackingResult;
			this.resultArray = trackingResultArray;
			this.difference = diff;
		}
		
		
		/*public override function clone()
		{
			return new LightEvent(type, bubbles, cancelable, result, resultArray,difference);
		}*/
		
		public override function toString():String
		{
			return formatToString("LightEvent","type","bubbles","cancelable","eventPhase","result","resultArray","difference");
		}
	}
}
