package {

	import de.derhess.iaCam.CamButton;
	import de.derhess.iaCam.CamButtonManager;
	import de.derhess.iaCam.CamButtonEvent;
	import flash.display.Bitmap;
	
	import com.jefr.utils.FPS;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.geom.Rectangle;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.events.Event;
	import flash.events.MouseEvent;


	[SWF(width='400', height='345', backgroundColor='0xD1A76F', frameRate='40')]
	public class XFighterCamButton extends Sprite
	{
		public var _btnManager:CamButtonManager;
		public var _XFighter:World3D;
		public var _webcam:Sprite;
		public var _speed:int;
		
		public var _leftCamBTN:CamButton;
		public var _leftBTN:Sprite;
		public var _leftBTNactive:Sprite;
		
		public var _rightCamBTN:CamButton;
		public var _rightBTN:Sprite;
		public var _rightBTNactive:Sprite;
		
		public var _topCamBTN:CamButton;
		public var _topBTN:Sprite;
		public var _topBTNactive:Sprite;
		
		public var _bottomCamBTN:CamButton;
		public var _bottomBTN:Sprite;
		public var _bottomBTNactive:Sprite;
		
		public var _debug_txt:TextField;
		
		public function XFighterCamButton()
		{
			init();
			addFps();
			addGUI();
		}
		
		private function init():void
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.quality = StageQuality.HIGH;
			
			
			/////////////////////////////////////////////////////////////////
			// Kameratracking
			var cam:Camera = Camera.getCamera();
			var vid:Video = new Video(320,240);
			vid.attachCamera(cam);
			
			// Webcam Container;
			this._webcam = new Sprite();
			this._webcam.addChild(vid);
			
			// Korrektur Spiegelbild des Webcamsignals
			var mirrorMatrix:Matrix = new Matrix();
			mirrorMatrix.scale(-1,1);
			vid.transform.matrix = mirrorMatrix;
			vid.x = 320;
				
			addChild(this._webcam);
			// ungefhre mittige Ausrichtung, fr die bessere Usability
			this._webcam.x = 40;
			this._webcam.y = 50;
		
			// CamButtons initialisieren
			this._btnManager = new CamButtonManager(this._webcam,CamButtonManager.DYNAMIC);
			this._btnManager.setQuantityFrames(10);
			this._btnManager.setAccuracy(30);
			// Erstelle die HotArea Bereiche im Kamerabild
			this._rightCamBTN = this._btnManager.createCamButton(270,140,30,30);
			this._leftCamBTN = this._btnManager.createCamButton(20,140,30,30);
			this._bottomCamBTN = this._btnManager.createCamButton(60,15,30,30);
			this._topCamBTN = this._btnManager.createCamButton(230,15,30,30);
			// Zuordnung der CamButton Listener
			this._rightCamBTN.addEventListener(CamButtonEvent.ON_HAND,rightHand);
			this._rightCamBTN.addEventListener(CamButtonEvent.ON_HAND_OVER,rightHand);
			this._rightCamBTN.addEventListener(CamButtonEvent.ON_HAND_OFF,rightHandOff);
			this._leftCamBTN.addEventListener(CamButtonEvent.ON_HAND,leftHand);
			this._leftCamBTN.addEventListener(CamButtonEvent.ON_HAND_OVER,leftHand);
			this._leftCamBTN.addEventListener(CamButtonEvent.ON_HAND_OFF,leftHandOff);
			this._bottomCamBTN.addEventListener(CamButtonEvent.ON_HAND,bottomHand);
			this._bottomCamBTN.addEventListener(CamButtonEvent.ON_HAND_OVER,bottomHand);
			this._bottomCamBTN.addEventListener(CamButtonEvent.ON_HAND_OFF,bottomHandOff);
			this._topCamBTN.addEventListener(CamButtonEvent.ON_HAND,topHand);
			this._topCamBTN.addEventListener(CamButtonEvent.ON_HAND_OVER,topHand);
			this._topCamBTN.addEventListener(CamButtonEvent.ON_HAND_OFF,topHandOff);
			
			////////////////////////////////////////////////////////////////
			// Erstellung 3D Objekt
			this._XFighter = new World3D();
			addChild( this._XFighter);
			
			////////////////////////////////////////////////////////////////
			//  Renderzyklus initialisieren
			addEventListener(Event.ENTER_FRAME,start);
			this._speed = 2;
			
			////////////////////////////////////////////////////////////////
			// Debugggin Information
			this._debug_txt = new TextField();
			this._debug_txt.width = 250;
			addChild(this._debug_txt);
			
			var deb_Bitmap:Bitmap = new Bitmap(this._btnManager.getBitmapData());
			addChild(deb_Bitmap);
			
		}
		
		// Render und Tracking Zyklus Funktion
		private function start(e:Event):void {
			this._XFighter.render();		
			this._btnManager.startAnalyze();
			//this._debug_txt.text = "RotX: " +Math.floor(this._XFighter._collada.rotationX) + " RotY: "+Math.floor(this._XFighter._collada.rotationY) +" RotZ:"+Math.floor(this._XFighter._collada.rotationZ);
		}
		
		
		// Perfomance Anzeige
		private function addFps():void
		{
			var fps:FPS = new FPS();
			addChild( fps );
		}
		
		//// GUI Funktionalitt und Visualisierung der CamButtons
		private function addGUI():void {
			// Bottom Button
			var temp1a:* = new AssetManager.CamBTN;
			this._bottomBTN = new Sprite();
			this._bottomBTN.addChild(temp1a);
			var temp1b:* = new AssetManager.CamBTNactive;
			this._bottomBTNactive = new Sprite();
			this._bottomBTNactive.addChild(temp1b);
			this._bottomBTN.rotation = this._bottomBTNactive.rotation = 180;
			this._bottomBTN.x = this._bottomBTNactive.x = 90 + this._webcam.x;
			this._bottomBTN.y = this._bottomBTNactive.y = 45 + this._webcam.y;
			addChild(this._bottomBTNactive)
			addChild(this._bottomBTN);
			this._bottomBTNactive.visible = false;
			
			// Top Button
			var temp2a:* = new AssetManager.CamBTN;
			this._topBTN = new Sprite();
			this._topBTN.addChild(temp2a);
			var temp2b:* = new AssetManager.CamBTNactive;
			this._topBTNactive = new Sprite();
			this._topBTNactive.addChild(temp2b);
			this._topBTN.x = this._topBTNactive.x = 230 + this._webcam.x;
			this._topBTN.y = this._topBTNactive.y = 15 + this._webcam.y;
			addChild(this._topBTNactive);
			addChild(this._topBTN);
			this._topBTNactive.visible = false;
			
			// Left Button
			var temp3a:* = new AssetManager.CamBTN;
			this._leftBTN = new Sprite();
			this._leftBTN.addChild(temp3a);
			var temp3b:* = new AssetManager.CamBTNactive;
			this._leftBTNactive = new Sprite();
			this._leftBTNactive.addChild(temp3b);
			this._leftBTN.rotation = this._leftBTNactive.rotation = -90;
			this._leftBTN.x = this._leftBTNactive.x = 20 + this._webcam.x;
			this._leftBTN.y = this._leftBTNactive.y = 170 + this._webcam.y;
			addChild(this._leftBTNactive);
			addChild(this._leftBTN);
			this._leftBTNactive.visible = false;
			
			// Right Button
			var temp4a:* = new AssetManager.CamBTN;
			this._rightBTN = new Sprite();
			this._rightBTN.addChild(temp4a);
			var temp4b:* = new AssetManager.CamBTNactive;
			this._rightBTNactive = new Sprite();
			this._rightBTNactive.addChild(temp4b);
			this._rightBTN.rotation = this._rightBTNactive.rotation = 90;
			this._rightBTN.x = this._rightBTNactive.x = 300 + this._webcam.x;
			this._rightBTN.y = this._rightBTNactive.y = 140 + this._webcam.y;
			addChild(this._rightBTNactive);
			addChild(this._rightBTN);
			this._rightBTNactive.visible = false;
			
		}
		
		///////////////// Listener ///////////////////////////
		private function rightHand(e:CamButtonEvent):void {
			this._rightBTNactive.visible = true;
			this._rightBTN.visible = false;
			this._XFighter._collada.rotationY += this._speed;
		}
		
		private function rightHandOff(e:CamButtonEvent):void {
			this._rightBTNactive.visible = false;
			this._rightBTN.visible = true;
		}
		
		private function leftHand(e:CamButtonEvent):void {
			this._leftBTNactive.visible = true;
			this._leftBTN.visible = false;
			this._XFighter._collada.rotationY -= this._speed;
		}
		
		private function leftHandOff(e:CamButtonEvent):void {
			this._leftBTNactive.visible = false;
			this._leftBTN.visible = true;
		}
		
		private function bottomHand(e:CamButtonEvent):void {
			this._bottomBTNactive.visible = true;
			this._bottomBTN.visible = false;
			this._XFighter._collada.rotationX -= this._speed;
		}
		
		private function bottomHandOff(e:CamButtonEvent):void {
			this._bottomBTNactive.visible = false;
			this._bottomBTN.visible = true;
		}
		
		private function topHand(e:CamButtonEvent):void {
			this._topBTNactive.visible = true;
			this._topBTN.visible = false;
			this._XFighter._collada.rotationX += this._speed;
		}
		
		private function topHandOff(e:CamButtonEvent):void {
			this._topBTNactive.visible = false;
			this._topBTN.visible = true;
		}

	}
}