package {

	import de.derhess.iaCam.LightTracking;
	import de.derhess.iaCam.LightEvent;	
	import com.jefr.utils.FPS;
	
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.geom.Rectangle;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.events.Event;
	import flash.events.MouseEvent;


	[SWF(width='400', height='345', backgroundColor='0xD1A76F', frameRate='40')]
	public class XFighterLightTracking extends Sprite
	{
		public var _tracker:LightTracking;
		public var _XFighter:World3D;
		public var _hotpoints:Sprite;
		public var _webcam:Sprite;
		public var _trackingModus:int;
		
		public var oneLight:SimpleButton;
		public var twoLight:SimpleButton;
		public var videoBTN:SimpleButton;
		public var _debug_txt:TextField;
		
		public function XFighterLightTracking()
		{
			init();
			addFps();
			addGUI();
		}
		
		private function init():void
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.quality = StageQuality.HIGH;
			
			
			/////////////////////////////////////////////////////////////////
			// Kameratracking
			var cam:Camera = Camera.getCamera();
			var vid:Video = new Video(320,240);
			vid.attachCamera(cam);
			
			// Webcam Container;
			this._webcam = new Sprite();
			this._webcam.addChild(vid);
			
			// Korrektur Spiegelbild des Webcamsignals
			var mirrorMatrix:Matrix = new Matrix();
			mirrorMatrix.scale(-1,1);
			vid.transform.matrix = mirrorMatrix;
			vid.x = 320;
				
			addChild(this._webcam);
			// ungefhre mittige Ausrichtung, fr die bessere Usability
			this._webcam.x = 40;
			this._webcam.y = 50;
			
			//Hotpoint Sprite der Bhne hinzufgen
			this._hotpoints = new Sprite();
			addChild(this._hotpoints);
			
			// Tracking initialisieren
			this._tracker = new LightTracking(this._webcam,200);
			
			this._tracker.addEventListener(LightEvent.RESULT_ONE_LIGHT,oneResult);
			this._tracker.addEventListener(LightEvent.RESULT_MORE_LIGHTS,moreResult);
			this._tracker.addEventListener(LightEvent.NO_LIGHT_FOUND,noLight);
			
			////////////////////////////////////////////////////////////////
			// Erstellung 3D Objekt
			this._XFighter = new World3D();
			addChild( this._XFighter);
			
			////////////////////////////////////////////////////////////////
			//  Renderzyklus initialisieren
			addEventListener(Event.ENTER_FRAME,start);
			
			this._debug_txt = new TextField();
			this._debug_txt.width = 250;
			addChild(this._debug_txt);
			
			this._trackingModus = LightTracking.ONE_LIGHT;
		}
		
		// Render und Tracking Zyklus Funktion
		private function start(e:Event):void {
			this._XFighter.render();		
			this._tracker.startTracking(this._trackingModus);
			//this._debug_txt.text = "RotX: " +Math.floor(this._XFighter._collada.rotationX) + " RotY: "+Math.floor(this._XFighter._collada.rotationY) +" RotZ:"+Math.floor(this._XFighter._collada.rotationZ);
		}
		
		// Tracking Handler fr ein Licht
		private function oneResult(e:LightEvent):void {
			trace("Licht gefunden");
			
			var rect:Rectangle = e.result;
			// Variablen fr Beschleunigung
			var Xproz:int = 0;
			var Yproz:int = 0;
			
			var maxRot:Number = 60; // Maximaler Lenkwinkel des XFighters
			var sphereSpeed:int = 5; // Geschwindigkeit der HintergrundRotation
			
			
			// Hotpoint zeichnen
			this._hotpoints.graphics.clear();
			this._hotpoints.graphics.lineStyle(2,0xFFFF06);
			this._hotpoints.graphics.drawRect(rect.x+this._webcam.x,rect.y+this._webcam.y,rect.width,rect.height);
			
			
			// Wenn Licht auf der linken Seite ist, lenke nach links
			if(rect.x > 0 && rect.x < 140) {
				
				Xproz = Math.floor(((Math.abs(rect.x-140)/140)*100));
				this._XFighter._collada.rotationY = (Xproz/100)*(-maxRot);
				// HintergrundAnimation fr einen FluggefhlFake		
				//this._XFighter._sphere.rotationY += this._XFighter._collada.rotationY;
				
			// Wenn Licht auf der rechten Seite ist, lenke nach rechts
			} else if(rect.x > 180 && rect.x < 320) {
				
				Xproz = Math.floor(((rect.x-180)/120)*100);
				this._XFighter._collada.rotationY = (Xproz/100)*maxRot;
				// HintergrundAnimation fr einen FluggefhlFake		
				//this._XFighter._sphere.rotationY += -this._XFighter._collada.rotationY;
				
			}
			
			// Wenn Licht auf der oberen Seite ist, lenke nach unten
			if(rect.y > 0 && rect.y < 100) {
				
				Yproz = Math.abs(rect.y-100);
				this._XFighter._collada.rotationX = (Yproz/100)*maxRot;
				// HintergrundAnimation fr einen FluggefhlFake		
				//this._XFighter._sphere.rotationX += this._XFighter._collada.rotationX;
				
			// Wenn Licht auf der unteren Seite ist, lenke nach oben
			} else if(rect.y > 140 && rect.y < 240) {
				
				Yproz = rect.y-140; // eigentlich 100
				this._XFighter._collada.rotationX =(Yproz/100)*(-maxRot);
				// HintergrundAnimation fr einen FluggefhlFake		
				//this._XFighter._sphere.rotationX += -this._XFighter._collada.rotationX;
				
			}
			
			// Fr den Realismus noch ein bissl Neigung eingebaut
			this._XFighter._collada.rotationZ = -(this._XFighter._collada.rotationY / 1.5);
			
		}
		
		// Handler wenn keine Lichter gefunden werden knnen
		private function noLight (e:LightEvent):void {
			trace("Es konnte kein Licht gefunden werden");
			this._hotpoints.graphics.clear();
			
			this._XFighter._collada.rotationX = this._XFighter._collada.rotationY = this._XFighter._collada.rotationZ = 0;
			
		
		}
		
		// Tracking Handler fr 2 Lichter
		private function moreResult (e:LightEvent):void {
			trace("Mehr Lichter Tracking");
			
			//berprfen ob genau 2 Lichter am Start sind
			if(e.resultArray.length == 2) {
				
				var left_rect:Rectangle = null; 
				var right_rect:Rectangle = null;
				// Zuordnung der richtigen Seite der Rechtecke
				if(e.resultArray[0].x < e.resultArray[1].x) {
					left_rect = e.resultArray[0];
					right_rect = e.resultArray [1];
				} else {
					left_rect = e.resultArray[1];
					right_rect = e.resultArray[0];
				}
				
				
				//Zeichnung der Hotpoints
				this._hotpoints.graphics.clear();
				this._hotpoints.graphics.lineStyle(2,0xFFFF06);
				this._hotpoints.graphics.drawRect(left_rect.x+this._webcam.x,left_rect.y+this._webcam.y,left_rect.width,left_rect.height);
				this._hotpoints.graphics.lineStyle(2,0xAAFF06);
				this._hotpoints.graphics.drawRect(right_rect.x+this._webcam.x,right_rect.y+this._webcam.y,right_rect.width,right_rect.height);
				this._hotpoints.graphics.lineStyle(4,0xFFFF06);
				this._hotpoints.graphics.moveTo(left_rect.x+(left_rect.width/2)+this._webcam.x,left_rect.y+(left_rect.height/2)+this._webcam.y);
				this._hotpoints.graphics.lineTo(right_rect.x+(right_rect.width/2)+this._webcam.x,right_rect.y+(right_rect.height/2)+this._webcam.y);
				
				var hypo:Number = Point.distance(left_rect.topLeft,right_rect.topLeft);
				var ylength:Number = right_rect.y-left_rect.y;
				
				// Rotoation fr Neigung ausrechnen
				var rotBogen:Number = Math.sin(ylength/hypo);
				var rotGrad:int = Math.floor(rotBogen*(180/Math.PI));			
				// Neigung XFighter
				this._XFighter._collada.rotationZ = -rotGrad;
				this._XFighter._collada.rotationY = rotGrad;
				
				// Neigung um die X-Achse
				var temp_y:int = Math.abs(left_rect.y -right_rect.y);
				
				if(left_rect.y < right_rect.y) {
					temp_y += left_rect.y; 
				} else {
					temp_y += right_rect.y;
				}
				
				// Hilfsvariablen
				var maxRot:int = 60;
				var Xproz:int = 0;
				var Yproz:int = 0;
				// Wenn Licht auf der oberen Seite ist, lenke nach unten
				if(temp_y > 0 && temp_y < 100) {
				
					Yproz = Math.abs(temp_y-100);
					this._XFighter._collada.rotationX = (Yproz/100)*maxRot;

				// Wenn Licht auf der unteren Seite ist, lenke nach oben
				} else if(temp_y > 140 && temp_y < 240) {
					
					Yproz = temp_y-140; // eigentlich 100
					this._XFighter._collada.rotationX =(Yproz/100)*(-maxRot);				
				}
				
			} else {
				trace("Zu wenig oder zuviel Lichter");
			}
		}
		
		// Perfomance Anzeige
		private function addFps():void
		{
			var fps:FPS = new FPS();
			addChild( fps );
		}
		
		
		//// GUI Funktionalitt zum Wechseln zwischen den zwei Modis
		private function addGUI():void {
			var temp1:* = new AssetManager.OneLightBTN;
			oneLight = new SimpleButton(temp1,temp1,temp1,temp1);
			oneLight.x = 60;
			oneLight.y = 310;
			oneLight.addEventListener(MouseEvent.MOUSE_DOWN,clickOneLight);
			addChild(oneLight);
			
			var temp2:* = new AssetManager.TwoLightBTN;
			twoLight = new SimpleButton(temp2,temp2,temp2,temp2);
			twoLight.x = oneLight.x+100;
			twoLight.y = oneLight.y;
			twoLight.addEventListener(MouseEvent.MOUSE_DOWN,clickTwoLight);
			addChild(twoLight);
			
			var temp3:* = new AssetManager.VideoBTN;
			videoBTN = new SimpleButton(temp3,temp3,temp3,temp3);
			videoBTN.x = twoLight.x +100;
			videoBTN.y = oneLight.y;
			addChild(videoBTN);
		}
		
		// Handler fr die Buttons
		private function clickOneLight(e:MouseEvent):void {
			this._trackingModus = LightTracking.ONE_LIGHT;
		}
		
		private function clickTwoLight(e:MouseEvent):void {
			this._trackingModus = LightTracking.MORE_LIGHTS;

		}
	}
}