/************************************************************************************************************
//CamButton Class ver 2.5 erstellt am 9. Oktober 2007 - portiert auf ActionScript 3
//
// Diese Klasse beinhaltet alle geometrischen Informationen (Rechteck) einer Hot Area des Webcambildes und
//  zustzlich gehren noch die Ereignisfunktionen dazu. Die Klasse kann nur in Verbindung der CamButtonManager Klasse
// verwendet werden
//
// author: Florian Weil --- http://www.derhess.de
//
// Die Klasse kann frei fr nicht kommerzielle Zwecke verwendet werden. 
// Bei kommerzieller Verwendung bitte eine kurze Mail an info@derhess.de 
//

/************************************************************************************************************/


package de.derhess.iaCam {
	
	
	import flash.events.EventDispatcher;
	import flash.geom.Rectangle;
	import flash.geom.Point;

	public class CamButton extends EventDispatcher{
		
		private var state:Boolean; // Ist die Hand ber den Button oder nicht
	
		private var x:int;
		private var y:int;
		private var width:int;
		private var height:int;
		
		private var scaleFactor:Number;
		
		// Konstruktor
		public function CamButton(xpos:int,ypos:int,breite:int,hoehe:int,scale:int) {
			this.scaleFactor = 100/scale;
			
			this.x = int(Math.round(xpos/this.scaleFactor));
			this.y = int(Math.round(ypos/this.scaleFactor));
			this.width = int(Math.round(breite/this.scaleFactor));
			this.height = int(Math.round(hoehe/this.scaleFactor));
			
			this.state = false; 
		}
		
		public function move(xpos:int,ypos:int):void {
			this.x = int(Math.round(xpos/this.scaleFactor));
			this.y = int(Math.round(ypos/this.scaleFactor));
		}
		
		public function changeSize(breite:int,hoehe:int):void {
			this.width = int(Math.round(breite/this.scaleFactor));
			this.height = int(Math.round(hoehe/this.scaleFactor));
		}
		
		public function getPosition():Point {
			return new Point(this.x*this.scaleFactor,this.y*this.scaleFactor);
		}
		
		public function getCamButtonRect():Rectangle {
			return new Rectangle(this.x*this.scaleFactor,this.y*this.scaleFactor,this.width*this.scaleFactor,this.height*this.scaleFactor);
		}
		
		// Rechteck fr die Bildanalyze
		public function getAnalyzeRect():Rectangle {
			return new Rectangle(this.x,this.y,this.width,this.height);
		}
		
		public function setState(bool:Boolean):void {
			this.state = bool;
		}
		
		public function getState():Boolean {
			return this.state;
		}
			
	}
	
}
